VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "HmacSha256 Demo"
   ClientHeight    =   5880
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   9210
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5880
   ScaleWidth      =   9210
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtLog 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5115
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   720
      Width           =   9075
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test"
      Height          =   495
      Left            =   6420
      TabIndex        =   2
      Top             =   60
      Width           =   915
   End
   Begin VB.ComboBox cboCase 
      Height          =   345
      Left            =   1020
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   135
      Width           =   5295
   End
   Begin VB.Label Label1 
      Caption         =   "Test case"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'HMAC-SHA-256 Test vectors from RFC 4231:
'
'     Identifiers and Test Vectors for HMAC-SHA-224, HMAC-SHA-256,
'                     HMAC-SHA-384, and HMAC-SHA-512

Private Const TEST_KEYS As String = _
        "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b" & "0b0b0b0b|" _
      & "4a656665|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaa|" _
      & "0102030405060708090a0b0c0d0e0f10" & "111213141516171819|" _
      & "0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c" & "0c0c0c0c|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaa|" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" & "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" _
      & "aaaaaa"
Private Const TEST_DATA As String = _
        "4869205468657265|" _
      & "7768617420646f2079612077616e7420" & "666f72206e6f7468696e673f|" _
      & "dddddddddddddddddddddddddddddddd" & "dddddddddddddddddddddddddddddddd" _
      & "dddddddddddddddddddddddddddddddd" & "dddd|" _
      & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" _
      & "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd" & "cdcd|" _
      & "546573742057697468205472756e6361" & "74696f6e|" _
      & "54657374205573696e67204c61726765" & "72205468616e20426c6f636b2d53697a" _
      & "65204b6579202d2048617368204b6579" & "204669727374|" _
      & "54686973206973206120746573742075" & "73696e672061206c6172676572207468" _
      & "616e20626c6f636b2d73697a65206b65" & "7920616e642061206c61726765722074" _
      & "68616e20626c6f636b2d73697a652064" & "6174612e20546865206b6579206e6565" _
      & "647320746f2062652068617368656420" & "6265666f7265206265696e6720757365" _
      & "642062792074686520484d414320616c" & "676f726974686d2e"
Private Const TEST_EXPECTED As String = _
        "b0344c61d8db38535ca8afceaf0bf12b" & "881dc200c9833da726e9376c2e32cff7|" _
      & "5bdcc146bf60754e6a042426089575c7" & "5a003f089d2739839dec58b964ec3843|" _
      & "773ea91e36800e46854db8ebd09181a7" & "2959098b3ef8c122d9635514ced565fe|" _
      & "82558a389a443c0ea4cc819899f2083a" & "85f0faa3e578f8077a2e3ff46729665b|" _
      & "a3b6167473100ee06e0c796c2955552b|" _
      & "60e431591ee0b67f0d8a26aacbf5b77f" & "8e0bc6213728c5140546040f0ee37f54|" _
      & "9b09ffa71b942fcb27635fbcd5b0e944" & "bfdc63644f0713938a7f51535c3a35e2"

Private strKeys() As String
Private strData() As String
Private strExpected() As String
Private HS256 As HS256

Private Function Fold(ByVal S As String) As String
    With HS256
        S = .Encode(.Decode(S), edfHexAsciiAddr, efCrLf)
    End With
    S = vbTab & Replace$(S, vbNewLine, vbNewLine & vbTab)
    Fold = Left$(S, Len(S) - 1)
End Function

Private Sub cboCase_Click()
    With txtLog
        .Text = ""
        .SelStart = 0
    End With
    cmdTest.SetFocus
End Sub

Private Sub cmdTest_Click()
    Dim intCase As Integer
    Dim bytSig() As Byte
    
    intCase = cboCase.ListIndex '1 (one) less than RFC 4231 case numbers.
    With txtLog
        .Text = ""
        .SelStart = 0
        .SelText = cboCase.List(intCase) & vbNewLine _
                 & String$(Len(cboCase.List(intCase)), "") & vbNewLine
        .SelText = "Key:" & vbNewLine & Fold(strKeys(intCase))
        .SelText = "Data:" & vbNewLine & Fold(strData(intCase))
        With HS256
            bytSig = .HmacSha256(.Decode(strKeys(intCase)), _
                                 .Decode(strData(intCase)))
            If intCase = 4 Then ReDim Preserve bytSig(15) 'Truncate to 128 bits ("Case 5").
            txtLog.SelText = "HmacSha256 result:" & vbNewLine _
                           & Fold(.Encode(bytSig))
        End With
        .SelText = "Expected (RFC) result:" & vbNewLine & Fold(strExpected(intCase))
        .SelStart = 0
    End With
End Sub

Private Sub Form_Load()
    strKeys = Split(TEST_KEYS, "|")
    strData = Split(TEST_DATA, "|")
    strExpected = Split(TEST_EXPECTED, "|")
    Set HS256 = New HS256
    Show
    With cboCase
        .AddItem "Case 1"
        .AddItem "Case 2 - key shorter than the length of the HMAC output"
        .AddItem "Case 3 - combined length of key and data > 64 bytes"
        .AddItem "Case 4 - combined length of key and data > 64 bytes"
        .AddItem "Case 5 - truncation of output to 128 bits"
        .AddItem "Case 6 - key larger than 128 bytes"
        .AddItem "Case 7 - key and data that is larger than 128 bytes"
        .ListIndex = 0
    End With
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        If Width < 9450 Then Width = 9450
        If Height < 3690 Then Height = 3690
        With txtLog
            .Move 0, .Top, ScaleWidth, ScaleHeight - .Top
        End With
    End If
End Sub
